<?php
/*
	 /'\_/`\                                    
	/\      \     __      ___      __     ___   
	\ \ \__\ \  /'__`\  /' _ `\  /'_ `\  / __`\ 
	 \ \ \_/\ \/\ \L\.\_/\ \/\ \/\ \L\ \/\ \L\ \
	  \ \_\\ \_\ \__/.\_\ \_\ \_\ \____ \ \____/
	   \/_/ \/_/\/__/\/_/\/_/\/_/\/___L\ \/___/ 
	                               /\____/      
	                               \_/__/       
	@author Leon Hartley
*/

class Account extends Controller {
	public function __construct() {
		parent::__construct();
	}

	public function base() {

		if(!Session::isAuthed()) { Router::sendTo(); }

		$this->load_view("account");

		$this->view->bind("page->description", 'Account Settings');
		$this->view->data->name = 'account';
		$this->view->data->tab = 'me';

		if(isset($_GET['section'])) {
			$this->view->data->section = $_GET['section'];
		} else {
			$this->view->data->section = 'profile';
		}

		if(isset($_SESSION['error'])) {
			$this->view->data->error = $_SESSION['error'];

			unset($_SESSION['error']);
		}

		if(isset($_SESSION['success'])) {
			$this->view->data->success = true;

			unset($_SESSION['success']);
		}

		$this->view->publish();
	}

	public function save() {
		if(!Session::isAuthed()) { Router::sendTo(); }

		if(isset($_GET['section'])) {

			switch($_GET['section']) {

				default:
					Router::sendTo('account');
				break;

				case 'profile':
					$data = array('updateMotto', 'emailNewsletterEnabled', 'blockNewFriends');

					$form = new Form('post', $data);

					if($form->check()) {
						$form->produce();

						$id = Session::getAuth();
						$user = R::load('users', $id);

						if($user->motto != $form->field->updateMotto) {
							$user->motto = $form->field->updateMotto;
						}

						if($user->block_newfriends != (($form->field->blockNewFriends) ? '1' : '0')) {
							$user->block_newfriends = (($form->field->blockNewFriends) ? '1' : '0');
						}

						R::store($user);

						$_SESSION['success'] = true;
					} else {
						$_SESSION['error'] = 'fields';
					}

					Router::sendTo('account?section=profile');

				break;

				case 'password':
					$data = array('currpass', 'newpass1', 'newpass2');

					$form = new Form('post', $data);

					if($form->check()) {
						$form->produce();

						$password = password($form->field->currpass);

						if(Session::auth()->password != $password) {
							$_SESSION['error'] = 'password';
							Router::sendTo('account?section=password');
						}

						if($form->field->newpass1 != $form->field->newpass2) {
							$_SESSION['error'] = 'passwords';
							Router::sendTo('account?section=password');
						}

						$user = R::load('users', Session::getAuth());

						$user->password = password($form->field->newpass1);

						R::store($user);
						
						$_SESSION['success'] = true;
					} else {
						$_SESSION['error'] = 'fields';
					}

					Router::sendTo('account?section=password');

				break;

				case 'email': 
					// handle email changes
				break;

				case 'trade':
					// handle trade changes
				break;

			}

		} else {
			Router::sendTo('account');
		}
	}
}