<?php
/*
	 /'\_/`\                                    
	/\      \     __      ___      __     ___   
	\ \ \__\ \  /'__`\  /' _ `\  /'_ `\  / __`\ 
	 \ \ \_/\ \/\ \L\.\_/\ \/\ \/\ \L\ \/\ \L\ \
	  \ \_\\ \_\ \__/.\_\ \_\ \_\ \____ \ \____/
	   \/_/ \/_/\/__/\/_/\/_/\/_/\/___L\ \/___/ 
	                               /\____/      
	                               \_/__/       
	@author Leon Hartley
*/

class Articles extends Controller {
	public function __construct() {
		parent::__construct();
	}

	public function base() {

		if(!Session::isAuthed()) { Router::sendTo(); }

		$this->load_view("articles");

		$this->view->bind("page->description", 'Articles');
		$this->view->data->name = 'articles';
		$this->view->data->tab = 'community';

		if(isset($_GET['id'])) {
			if(empty($_GET['id'])) {
				$this->view->data->article = 0;
				$this->renderArticle('Article not found.', 'The one who couldn\'t be found', 'The article you requested could not be found.', 'God');

			} else {
				$id = intval($_GET['id']);

				if(NewsDao::exists('id', $id)) {
					$article = NewsDao::get($id);

					$this->view->data->article = $id;
					$this->renderArticle($article->article_name, $article->article_description, $article->article_story, $article->article_author);
					$article->views = $article->views + 1;

					R::store($article);
				} else {
					$this->view->data->article = 0;

					$this->renderArticle('Article not found.', 'The one who couldn\'t be found', 'The article you requested could not be found.', 'God');
				}
			}
		} else {
			$article = NewsDao::getLatestOne();
			$this->view->data->article = $article->id;
			$this->renderArticle($article->article_name, $article->article_description, $article->article_story, $article->article_author);
			$article->views = $article->views + 1;
		}

		$this->view->publish();
	}

	public function renderArticle($name, $description, $story, $author) {
			$this->view->bind('article->title', $name);
			$this->view->bind('article->description', $description);
			$this->view->bind('article->content', $story);
			$this->view->bind('article->author', $author);
	}
}