<?php
/*
	 /'\_/`\                                    
	/\      \     __      ___      __     ___   
	\ \ \__\ \  /'__`\  /' _ `\  /'_ `\  / __`\ 
	 \ \ \_/\ \/\ \L\.\_/\ \/\ \/\ \L\ \/\ \L\ \
	  \ \_\\ \_\ \__/.\_\ \_\ \_\ \____ \ \____/
	   \/_/ \/_/\/__/\/_/\/_/\/_/\/___L\ \/___/ 
	                               /\____/      
	                               \_/__/       
	@author Leon Hartley
*/

class Campaigns extends Controller {

	public function __construct() {
		parent::__construct();
		
		if(!Session::isAuthed()) {
			Router::sendTo();
		}
		
		if(!Session::hasHousekeeping()) {
			Router::sendTo(); 
		}
	}

	public function base() {
		$this->load_view('housekeeping/campaigns');
		$this->view->publish();
	}
    
    public function edit() {
    
        if(isset($_GET['campaign'])) {
			if(empty($_GET['campaign'])) { Router::sendTo('housekeeping/campaigns'); }
			
			$id = intval($_GET['campaign']);
    
            if(!HkDao::campaign_exists($id)) {
                Router::sendTo('housekeeping/campaigns');
            }
        
            $this->load_view('housekeeping/campaigns_edit');
            $this->view->data->campaign = R::load('site_campaigns', $id);
            $this->view->publish();
        }
	}
    
    public function create() {
   
        if (!isset($_GET["add"]))
        {
            $this->load_view('housekeeping/campaigns_add');
            $this->view->publish();
        }
        else
        {
            $fields = array("name", "topstory", "description", "link");
            
            foreach ($fields as $value)
            {
                if (!isset($_POST[$value]))
                {
                    $this->load_view('housekeeping/response');
                    $this->view->data->status = "Error";
                    $this->view->data->alert_type = "important";
                    $this->view->data->error = "Unexpected error occured!";
                    $this->view->publish();
                    break;
                }
                else if ($_POST[$value] == "")
                {
                    $this->load_view('housekeeping/response');
                    $this->view->data->status = "Error";
                    $this->view->data->alert_type = "important";
                    $this->view->data->error = "You left a field blank!";
                    $this->view->publish();
                    break;
                }
            }
            
            $article = R::dispense('site_campaigns');
            $article->image_url = "/public/campaigns/" . $_POST['topstory'];
            $article->name = $_POST['name'];
            $article->description = $_POST['description'];
            $article->link = $_POST['link'];
            $id = R::store($article);
            
            $this->load_view('housekeeping/response');
            $this->view->data->status = "Success";
            $this->view->data->alert_type = "success";
            $this->view->data->error = "Campaign has been added! ";
            $this->view->publish();
        }
	}
    
    public function save() {
    
        $fields = array("id", "name", "topstory", "description", "link");
        
        foreach ($fields as $value)
        {
            if (!isset($_POST[$value]))
            {
                $this->load_view('housekeeping/response');
                $this->view->data->status = "Error";
                $this->view->data->alert_type = "important";
                $this->view->data->error = "You tried to save a campaign which didn't exist!";
                $this->view->publish();
                break;
            }
            else if ($_POST[$value] == "")
            {
                $this->load_view('housekeeping/response');
                $this->view->data->status = "Error";
                $this->view->data->alert_type = "important";
                $this->view->data->error = "You left a field blank!";
                $this->view->publish();
                break;
            }
        }
        
        R::exec("UPDATE site_campaigns SET name = ?, image_url = ?, description = ?, link = ? WHERE id = ". $_POST["id"], array($_POST["name"], "/public/campaigns/" . $_POST["topstory"], $_POST["description"], $_POST["link"]));
	
        $this->load_view('housekeeping/response');
        $this->view->data->status = "Success";
        $this->view->data->alert_type = "success";
        $this->view->data->error = "A campaign is saved!";
        $this->view->publish();
    }
    
    public function delete() {
    
        if (!isset($_GET["campaign"]))
        {
            $this->load_view('housekeeping/response');
            $this->view->data->status = "Error";
            $this->view->data->alert_type = "important";
            $this->view->data->error = "Unexpected error occured!";
            $this->view->publish();
            return;
        }
        else if ($_GET["campaign"] == "")
        {
            $this->load_view('housekeeping/response');
            $this->view->data->status = "Error";
            $this->view->data->alert_type = "important";
            $this->view->data->error = "Unknown article";
            $this->view->publish();
            return;
        }
    
        R::exec("DELETE FROM site_campaigns WHERE id = '". $_GET["campaign"] . "'");
	
        $this->load_view('housekeeping/response');
        $this->view->data->status = "Success";
        $this->view->data->alert_type = "success";
        $this->view->data->error = "Campaign has been deleted!";
        $this->view->publish();
    }
}