<?php
/*
	 /'\_/`\                                    
	/\      \     __      ___      __     ___   
	\ \ \__\ \  /'__`\  /' _ `\  /'_ `\  / __`\ 
	 \ \ \_/\ \/\ \L\.\_/\ \/\ \/\ \L\ \/\ \L\ \
	  \ \_\\ \_\ \__/.\_\ \_\ \_\ \____ \ \____/
	   \/_/ \/_/\/__/\/_/\/_/\/_/\/___L\ \/___/ 
	                               /\____/      
	                               \_/__/       
	@author Leon Hartley
*/

function clean($string) {
	return mysql_real_escape_string($string);
}

function password($string) {
	return return sha1($string . Sierra::getConfig()->security->string);
}

function MUS($command, $data = '') 
{
    $MUSdata = $command . chr(1) . $data; 
    $socket = @socket_create(AF_INET, SOCK_STREAM, getprotobyname('tcp')); 
    @socket_connect($socket, Sierra::getConfig()->ip, SiteDao::system("mus_port")); 
    @socket_send($socket, $MUSdata, strlen($MUSdata), MSG_DONTROUTE);     
    @socket_close($socket); 
}  

function valid_email($email) {
  return preg_match("^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,3})$^", $email);
}

function nicetime($date)
{
    if(empty($date)) {
        return "No date provided";
    }
    
    $periods         = array("second", "minute", "hour", "day", "week", "month", "year", "decade");
    $lengths         = array("60","60","24","7","4.35","12","10");
    
    $now             = time();
    $unix_date         = $date;
    
       // check validity of date
    if(empty($unix_date)) {    
        return "Bad date";
    }

    // is it future date or past date
    if($now > $unix_date) {    
        $difference     = $now - $unix_date;
        $tense         = "ago";
        
    } else {
        $difference     = $unix_date - $now;
        $tense         = "from now";
    }
    
    for($j = 0; $difference >= $lengths[$j] && $j < count($lengths)-1; $j++) {
        $difference /= $lengths[$j];
    }
    
    $difference = round($difference);
    
    if($difference != 1) {
        $periods[$j].= "s";
    }
    
    return "$difference $periods[$j] {$tense}";
}

function get_date($time) {
    $month = date("F", $time);
    $day = date("j", $time);
    $year = date("Y", $time);

    $string = (strlen($day) > 1 ? '' : '0') . $day . '-' . substr($month, 0, 3) . '' . '-' . $year;

    return $string;
}

function generateFigure($club=null,$gender=null){
//generateFigure function
//Generates a valid Habbo figure
//Copyright (R) 2009 - Yifan Lu (www.yifanlu.com)
//Please do not remove this :-)
	//$fail = "hd-629-14.ch-640-99.lg-720-69.sh-740-96.ea-1406-.fa-1204-.wa-2011-";
	if($gender == null){ if(rand(0,1) == 0){ $gender = "M"; }else{ $gender = "F"; } }
	if($club == null){ $club = (bool) rand(0,1); }
	$xml = simplexml_load_file('application/external/figuredata.xml');
	$figure = "";
	foreach($xml->sets->settype as $settype){
		if((string) $settype['mandatory'] == "1" || rand(0,1) == 1){
			$item['settype'] = $settype['type'];
			$palette = (int) $settype['paletteid'];
			$possible = array();
			foreach($settype->set as $xset){
				if($xset['gender'] != "U" && $xset['gender'] != $gender){ $fail = true; }
				if($xset['selectable'] == "0"){ $fail = true; }
				if($xset['colorable'] == "0"){ $color = false; }else{ $color = true; }
				if($xset['club'] == "1" && $club == false){ $fail = true; }
				if($fail != true){ $possible[] = array($xset['id'],$color); }
				$fail = false; $color = false;
			}
			$count = count($possible);
			$num = rand(0,$count-1);
			$item['set'] = $possible[$num][0];
			if($possible[$num][1] == false){ $item['color'] = ""; }else{
				$possible = array();
				foreach($xml->colors->palette[$palette-1]->color as $color){
					if($color['club'] == "1" && $club == false){ $fail = true; }
					if($color['selectable'] == "0"){ $fail = true; }
					if($fail != true){ $possible[] = $color['id']; }
					$fail = false;
				}
				$count = count($possible);
				$num = rand(0,$count-1);
				$item['color'] = $possible[$num];
			}
			$figure .= $item['settype']."-".$item['set']."-".$item['color'].".";
		}
	}
	$figure = substr($figure, 0, -1);
	return $figure;
}

function strstr_after($haystack, $needle, $case_insensitive = false) {
    $strpos = ($case_insensitive) ? 'stripos' : 'strpos';
    $pos = $strpos($haystack, $needle);
    if (is_int($pos)) {
        return substr($haystack, $pos + strlen($needle));
    }
    // Most likely false or null
    return $pos;
}

function indent($json) {

    $result      = '';
    $pos         = 0;
    $strLen      = strlen($json);
    $indentStr   = '  ';
    $newLine     = "\n";
    $prevChar    = '';
    $outOfQuotes = true;

    for ($i=0; $i<=$strLen; $i++) {

        // Grab the next character in the string.
        $char = substr($json, $i, 1);

        // Are we inside a quoted string?
        if ($char == '"' && $prevChar != '\\') {
            $outOfQuotes = !$outOfQuotes;
        
        // If this character is the end of an element, 
        // output a new line and indent the next line.
        } else if(($char == '}' || $char == ']') && $outOfQuotes) {
            $result .= $newLine;
            $pos --;
            for ($j=0; $j<$pos; $j++) {
                $result .= $indentStr;
            }
        }
        
        // Add the character to the result string.
        $result .= $char;

        // If the last character was the beginning of an element, 
        // output a new line and indent the next line.
        if (($char == ',' || $char == '{' || $char == '[') && $outOfQuotes) {
            $result .= $newLine;
            if ($char == '{' || $char == '[') {
                $pos ++;
            }
            
            for ($j = 0; $j < $pos; $j++) {
                $result .= $indentStr;
            }
        }
        
        $prevChar = $char;
    }

    return $result;
}

function startsWith($haystack, $needle)
{
    return !strncmp($haystack, $needle, strlen($needle));
}